routes/web.php
<?php

use App\Http\Controllers\Backend\AdminController;
use App\Http\Controllers\Backend\CategoryController;
use App\Http\Controllers\Backend\MenuController;
use App\Http\Controllers\Backend\ProductController;
use App\Http\Controllers\Backend\SettingController;
use App\Http\Controllers\Backend\SliderController;
use App\Http\Controllers\Frontend\HomeController;
use App\Http\Controllers\Frontend\CategoryControllerList;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});

Route::prefix('admin')->name('admin.')->group(function () {
    Route::get('/', [AdminController::class, 'index'])->name('index');
    Route::get('login', [AdminController::class, 'login'])->name('login');
    Route::post('post_login', [AdminController::class, 'postlogin'])->name('post_login');



    Route::get('category', [CategoryController::class, 'index'])->name('category.index');
    Route::get('category/create', [CategoryController::class, 'create'])->name('category.create');
    Route::post('category/store', [CategoryController::class, 'store'])->name('category.store');
    Route::get('category/edit/{id}', [CategoryController::class, 'edit'])->name('category.edit');
    Route::put('category/update/{id}', [CategoryController::class, 'update'])->name('category.update');
    Route::delete('category/destroy/{id}', [CategoryController::class, 'destroy'])->name('category.destroy');

    Route::get('menu', [MenuController::class, 'index'])->name('menu.index');
    Route::get('menu/create', [MenuController::class, 'create'])->name('menu.create');
    Route::post('menu/store', [MenuController::class, 'store'])->name('menu.store');
    Route::get('menu/edit/{id}', [MenuController::class, 'edit'])->name('menu.edit');
    Route::put('menu/update/{id}', [MenuController::class, 'update'])->name('menu.update');
    Route::delete('menu/destroy/{id}', [MenuController::class, 'destroy'])->name('menu.destroy');

    Route::get('product', [ProductController::class, 'index'])->name('product.index');
    Route::get('product/create', [ProductController::class, 'create'])->name('product.create');
    Route::post('product/store', [ProductController::class, 'store'])->name('product.store');
    Route::get('product/edit/{id}', [ProductController::class, 'edit'])->name('product.edit');
    Route::put('product/update/{id}', [ProductController::class, 'update'])->name('product.update');
    Route::delete('product/destroy/{id}', [ProductController::class, 'destroy'])->name('product.destroy');

    Route::get('slider', [SliderController::class, 'index'])->name('slider.index');
    Route::get('slider/create', [SliderController::class, 'create'])->name('slider.create');
    Route::post('slider/store', [SliderController::class, 'store'])->name('slider.store');
    Route::get('slider/edit/{id}', [SliderController::class, 'edit'])->name('slider.edit');
    Route::put('slider/update/{id}', [SliderController::class, 'update'])->name('slider.update');
    Route::delete('slider/destroy/{id}', [SliderController::class, 'destroy'])->name('slider.destroy');

    Route::get('setting', [SettingController::class, 'index'])->name('setting.index');
    Route::get('setting/create', [SettingController::class, 'create'])->name('setting.create');
    Route::post('setting/store', [SettingController::class, 'store'])->name('setting.store');
    Route::get('setting/edit/{id}', [SettingController::class, 'edit'])->name('setting.edit');
    Route::put('setting/update/{id}', [SettingController::class, 'update'])->name('setting.update');
    Route::delete('setting/destroy/{id}', [SettingController::class, 'destroy'])->name('setting.destroy');
});

//Frontend
Route::prefix('/')->name('.')->group(function (){
    Route::get('/', [HomeController::class, 'index'])->name('index');
    Route::get('category/{slug}/{id}',[CategoryControllerList::class,'category'])->name('category.product');
});

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;
    const ACTIVE = 1;
    const INACTIVE = 0;
    const DELETED = 1;
    const NOT_DELETED = 0;

    protected $table = 'categories';
    protected $fillable = [
        'parent_id',
        'name',
        'slug',
        'status',
        'deleted',
        'created_at',
        'updated_at',
    ];

    public function scopeGetCategory()
    {
        return $this::with(['parent', 'children'])->where('deleted', self::NOT_DELETED);
    }


    public function scopeGetCategoryParent()
    {
        return $this::where('deleted', self::NOT_DELETED)->where('parent_id', 0);
    }


    public function scopeGetCategoryChildren()
    {
        return $this::where('deleted', self::NOT_DELETED)->where('parent_id', '!=', 0);
    }


    public function parent()
    {
        return $this->belongsTo($this, 'parent_id');
    }


    public function getBySlug($slug)
    {
        return self::where(['slug' => $slug, 'status' => self::ACTIVE , 'deleted'=> self::NOT_DELETED])->first();
    }


    public function children()
    {
        return $this->hasMany($this, 'parent_id')->where('status',1);
    }


    public function getById($id)
    {
        return self::where(['id' => $id, 'status' => self::ACTIVE , 'deleted'=> self::NOT_DELETED])->first();
    }

    public function Products()
    {
        return $this->hasMany(Product::class,'category_id');
    }
}

app/Http/Controllers/Backend/AdminController.php
<?php

namespace App\Http\Controllers\Backend;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;

class AdminController extends Controller
{
    public function index(){
        return view('Backend.home');
    }

    public function login(){
        return view('Backend.login');
    }

    public function postlogin(Request $request){
        $remember = $request->has('remember_me') ? true : false;
        if(auth()->attempt([
            'email' => $request->email,
            'password' => $request->password
        ],$remember)){
            return redirect()->route('admin.index');
        }
    }

}

app/Http/Controllers/Backend/CategoryController.php
<?php

namespace App\Http\Controllers\Backend;

use App\Http\Controllers\Controller;
use App\Traits\LoggerTrait;
use Illuminate\Http\Request;
use App\Models\Category;
use App\Http\Requests\CategoryRequest;
use App\Helpers\Backend\Helpers;


class CategoryController extends Controller
{
    use LoggerTrait;

    public function index(Request $request)
    {
        try {
            $name = $request->get('name', '');
            $query = Category::GetCategory();
            if ($name) {
                $query->where('name', 'like', '%' . $name . '%');
            }
            $datas = $query->orderBy('id', 'DESC')->paginate(20);
            return view('Backend.category.index', compact('datas', 'name'));
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }

    public function create()
    {
        try {
            $listCategory = Category::GetCategoryParent()->get();
            return view('Backend.category.form', compact('listCategory'));
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }


    public function store(CategoryRequest $request)
    {
        try {
            $datas = $request->all();
            $datas['status'] = $request->has('status') ? Category::ACTIVE : Category::INACTIVE;
            $datas['slug'] = Helpers::createSlug($datas['name']);
            Category::create($datas);
            return redirect()->route('admin.category.index')->with('success', 'Thêm mới thành công');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->withInput()->with('error', 'Thêm mới thất bại');
        }
    }


    public function show($id)
    {
        //
    }


    public function edit($id)
    {
        try {
            $listCategory = Category::GetCategoryParent()->where('id', '!=', $id)->get();// không cho thằng cha gọi đến chính nó
            $category = Category::where('id', $id)->first();
            return $category ? view('backend.category.form', compact('listCategory', 'category')) : redirect()->back()->with('error', 'Danh mục không tồn tại!');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại sau!');
        }

    }

    public function update(CategoryRequest $request, $id)
    {
        try {
            $datas = $request->except(['_token', '_method']);
            $datas['status'] = $request->has('status') ? Category::ACTIVE : Category::INACTIVE;
            $datas['slug'] = Helpers::createSlug($datas['name']);
            Category::where('id', $id)->update($datas);
            return redirect()->route('admin.category.index')->with('success', 'Chỉnh sửa thành công');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->withInput()->with('error', 'Chỉnh sửa thất bại');
        }
    }

    public function destroy($id)
    {
        try {
            $datas = Category::where('id', $id)->first();
            if (!$datas) {
                return redirect()->back()->with('error', 'Danh mục không tồn tại');
            }
            $datas->deleted = Category::DELETED;
            $datas->save();
            return redirect()->route('admin.category.index')->with('success','Xóa thành công');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->withInput()->with('error', 'xóa thất bại');
        }
    }
}

app/Http/Controllers/Backend/MenuController.php
<?php

namespace App\Http\Controllers\Backend;

use App\Components\MenuRecusive;
use App\Http\Controllers\Controller;
use App\Http\Requests\MenuRequest;
use Illuminate\Http\Request;
use App\Models\Menu;
use App\Traits\LoggerTrait;
use App\Helpers\Backend\Helpers;



class MenuController extends Controller
{
    use LoggerTrait;
    private $menuRecusive;
    private $menu;
    public function __construct(MenuRecusive $menuRecusive, Menu $menu)
    {
        $this->menuRecusive = $menuRecusive;
        $this->menu = $menu;
    }
    public function index(Request $request)
    {
        try {
            $name = $request->get('name', '');
            $query = Menu::GetMenu();
            if ($name) {
                $query->where('name', 'like', '%' . $name . '%');
            }
            $menus = $query->orderBy('id', 'DESC')->paginate(20);
            $menusindex = $this->menuRecusive->menuRecusiveindex();
            return view('Backend.menu.index', compact('menus', 'name','menusindex'));
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }

    public function create()
    {
        try {
            $listMenu = $this->menuRecusive->menuRecusiveAdd();
            return view('backend.menu.form',compact('listMenu'));
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }


    public function store(MenuRequest $request)
    {
        try {
            $this->menu->create([
                'name' => $request->name,
                'parent_id' => $request->parent_id,
                'slug' => Helpers::createSlug($request->name)
            ]);
            return redirect()->route('admin.menu.index')->with('success','Thêm thành công');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }


    public function show($id)
    {
        //
    }


    public function edit($id)
    {
        try {
            $menu = $this->menu->find($id);
            $listMenu = $this->menuRecusive->menuRecusiveEdit($menu->parent_id);
            return view('backend.menu.form',compact('listMenu','menu'));
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }


    public function update(MenuRequest $request, $id)
    {
        try {
            $this->menu->find($id)->update([
                'name' => $request->name,
                'parent_id' => $request->parent_id,
                'slug' => Helpers::createSlug($request->name)
            ]);
            return redirect()->route('admin.menu.index')->with('success','Sửa thành công');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }

    public function destroy($id)
    {
        try {
            $this->menu->find($id)->delete();
            return redirect()->route('admin.menu.index')->with('success','Xóa thành công');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->withInput()->with('error', 'xóa thất bại');
        }
    }
}

app/Http/Controllers/Backend/SettingController.php
<?php

namespace App\Http\Controllers\Backend;

use App\Http\Controllers\Controller;
use App\Models\Setting;
use Illuminate\Http\Request;
use App\Traits\LoggerTrait;
use App\Http\Requests\SettingRequest;

class SettingController extends Controller
{
    use LoggerTrait;

    public function index()
    {
        try {
//            $name = $request->get('name', '');
//            $query = Slider::with(['category']);
//            if ($name) {
//                $query->where('name', 'like', '%' . $name . '%');
//            }
            $datas = Setting::orderBy('id', 'DESC')->paginate(10);
            return view('backend.setting.index', compact('datas'));

        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }


    public function create()
    {
        try {
            return view('backend.setting.form');

        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }

    public function store(SettingRequest $request)
    {
        try {
            $datas = [
                'config_key' => $request->config_key,
                'config_value' => $request->config_value,
                'type' => $request->type,
            ];
            $slider = Setting::create($datas);
            return redirect()->route('admin.setting.index')->with('Thêm mới thành công');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }


    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        try {
            $setting = Setting::findOrFail($id);
            return view('Backend.setting.form', compact('setting'));
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->with('error', 'Có lỗi xảy ra vui lòng thử lại!');
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        try {
            Setting::find($id)->delete();
            return redirect()->route('admin.setting.index')->with('success','Xóa thành công');
        } catch (\Exception $exception) {
            $this->logError($exception);
            return redirect()->back()->withInput()->with('error', 'xóa thất bại');
        }
    }
}

resources/views/Backend/category/form.blade.php
@extends('Backend.layouts.admin')

@section('title')
    {{isset($category) ? 'Chỉnh sửa danh mục' : 'Thêm mới danh mục'}}
@endsection

@section('content')
    <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <div class="content-header">
            <div class="container-fluid">
                <div class="row mb-2">
                        <div class="col-md-6">
                        <h1 class="m-0 text-dark">{{isset($category) ? 'Chỉnh sửa danh mục' : 'Thêm mới danh mục'}} </h1>
                        </div>
                       <div class="col-md-6 col-sm-12">
                         <a href="{{route('admin.category.index')}}" class="btn btn-outline-info float-md-right">
                            <i class="fas fa-arrow-circle-left"></i> <span>Quay về danh sách</span>
                         </a>
                     </div>

                </div><!-- /.row -->
            </div><!-- /.container-fluid -->
        </div>
        <!-- /.content-header -->

        <!-- Main content -->
        <div class="content">
            <div class="container-fluid">
                <div class="row">
                    <div class="col-md-6">
                        <form method="POST" action="{{ isset($category) ? route('admin.category.update', $category->id) : route('admin.category.store')}}" enctype="multipart/form-data" >
                            @csrf
                            @if(isset($category))
                               @method('PUT')
                            @endif
                            <div class="form-group">
                                <label class="label-required" >Tên danh mục</label>
                                <input required type="text" name="name" class="form-control @error('name') is-invalid @enderror" value="{{old('name',isset($category) ? $category->name : '')}}"
                                       placeholder="Nhập tên danh mục">
                                @error('name')
                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="exampleFormControlSelect1">Chọn danh mục cha <i style="font-size: 12px">* Bỏ qua nếu là danh mục cha</i></label>
                                <select class="form-control @error('parent_id') is-invalid @enderror" name="parent_id" id="parent_id">
                                    <option value="0">--Chọn menu cha--</option>
                                    @foreach($listCategory as $item)
                                        <option @if(old('parent_id',isset($category) ? $category->parent_id : '') == $item->id)
                                                    selected @endif value="{{$item->id}}"> {{$item->name}} </option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="form-group">
                                <label class="mr-2" for="status">Trạng thái</label>
                                <input type="checkbox" @if(old('status', (isset($category) && $category->status == 1) ? 'on' : '') == 'on') checked @endif name="status" data-bootstrap-switch data-off-color="danger" data-on-color="success">
                            </div>
                            @error('parent_id')
                            <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                            @enderror
                            <button type="submit" class="btn btn-primary">{{isset($category) ? 'Chỉnh sửa' : 'Thêm mới'}}</button>
                        </form>
                    </div>
                </div>
                <!-- /.row -->
            </div><!-- /.container-fluid -->
        </div>
        <!-- /.content -->
    </div>
@endsection
@section('js')
    <script>
        $('.select2').select2({
            theme: 'bootstrap4'
        });
        $("input[data-bootstrap-switch]").each(function () {
            $(this).bootstrapSwitch('state', $(this).prop('checked'));
        });
    </script>
@endsection

resources/views/Backend/category/index.blade.php
@extends('Backend.layouts.admin')

@section('title')
    Danh mục
@endsection

@section('content')
    <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <div class="content-header">
            <div class="container-fluid">
                <div class="row mb-4">
                    <div class="col-md-3 col-sm-12">
                        <h1 class=" text-dark">Danh sách danh mục </h1>
                    </div>
                    <div class="form-group col-md-5 col-sm-12 mt-1">
                        <form method="GET">
                            <div class="row">
                                <div class="col-8">
                                    <input name="name" value="{{$name ?? ''}}" placeholder="Tìm kiếm" type="search" class="form-control">
                                </div>
                                <div class="col-4">
                                    <button type="submit" class="btn btn-outline-info">Tìm kiếm</button>
                                </div>

                            </div>
                        </form>
                    </div>
                    <div class="col-md-4 col-sm-12">
                        <a href="{{route('admin.category.create')}}" class="btn btn-success float-right m-2">Thêm mới danh mục</a>
                    </div>
                    <div class="col-md-12">
                        <table class="table">
                            <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">Tên danh mục</th>
                                <th scope="col">Danh mục cha</th>
                                <th scope="col">Trạng thái</th>
                                <th scope="col">Hành động</th>
                            </tr>
                            </thead>
                            <tbody>
                            @forelse($datas as $value)
                            <tr>
                                <td>{{$value->id}}</td>
                                <td>{{$value->name}}</td>
                                <td>{{$value->parent ? $value->parent->name : ''}}</td>
                            <td>
                                @if($value->status)
                                    <span class="badge bg-success">Hiển thị</span>
                                @else
                                    <span class="badge bg-warning">Ẩn</span>
                                @endif
                            </td>
                            <td>
                                <a href="{{route('admin.category.edit',$value->id)}}" class="btn btn-outline-warning btn-sm">
                                    <i class="fas fa-edit"></i> <span>Sửa</span>
                                </a>
                                <button type="button" class="btn btn-outline-danger btn-sm" onclick="deleteData({{$value->id}})">
                                    <i class="fas fa-trash-alt"></i> <span>Xóa</span>
                                </button>
                                <form id="delete-form-{{ $value->id }}" action="{{route('admin.category.destroy',$value->id)}}" method="POST" class="d-none">
                                    @csrf()
                                    @method('DELETE')
                                </form>
                            </td>
                            </tr>
                            @empty
                                <tr>
                                    <td class="text-center" colspan="5">Không có dữ liệu</td>
                                </tr>
                            @endforelse
                            </tbody>
                        </table>
                    </div>
                </div><!-- /.row -->
            </div><!-- /.container-fluid -->
        </div>
        <!-- /.content-header -->
       <div class="card-footer clearfix">
        <ul class="pagination pagination-md m-0 " style="justify-content: center!important;">
            {{$datas->appends(request()->all())->links()}}
        </ul>
    </div>
        <!-- Main content -->
        <div class="content">
            <div class="container-fluid">
                <div class="row">
                </div>
                <!-- /.row -->
            </div><!-- /.container-fluid -->
        </div>
        <!-- /.content -->
    </div>
@endsection